#!/usr/bin/perl
 ##################################################################
# Autoresponder and Mailing List Manager                           #
# Version 4.1 Lite                                                 #
# Copyright 2005-2020                                              #
# A free script from:   http://free-software.biz/amlmlite.html     #
 ##################################################################
#                          COPYRIGHT NOTICE                        #
#                                                                  #
#   Copyright 2005-2020 http://free-software.biz/amlmpro.html      #
#                                                                  #
#          Please read license.htm or license.txt file             #
#             before proceeding with installation.                 #
#                                                                  #
# You are granted permission to use this Software as long as:      #
#                                                                  #
#  - You do not modify the Software in any way                     #
#  - You do not modify this agreement in any way                   #
#  - You do not claim ownership of any ammended files              #
#  - You do not remove any copyright notices                       #
#  - You do not change/remove the 'Autoresponder and Mailing List  #
#    Manager 4.1 Lite' name in any of the source files,            #
#    generated URLs and outgoing emails                            #
#                                                                  #
# Modifying, selling the code for this software over the Internet  #
# or in any other medium is forbidden.                             #
#                                                                  #
# If you really need to remove the return links, go to             #
# http://free-software.biz/amlmpro.html                            #
# and upgrade to the Pro version                                   #
#                                                                  #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,  #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES  #
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND         #
# NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT     #
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,     #
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING     #
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR    #
# OTHER DEALINGS IN THE SOFTWARE.                                  #
#                                                                  #
##################################################################

use POSIX;
use MIME::Lite;
use DBI;
use Time::Local;
use Net::SMTP;
local $DATA,$USER,$PASS;
local %CONF;
$c_file="cnf.rd";
$cfg_psd="Autoresponder and Mailing List Manager AMLM Lite Installation ";
%TYPESEND=(html=>"text/html",text=>"text/plain");
###############################
sub sequre
{
	local $_=$_[0];
	s/&/&amp;/g;
	s/"/&quot;/g;
	s/>/&gt;/g;
	s/</&lt;/g;

	if($_[1]!=1){
		s/\n/<br>\n/g;}
	return $_;
}
#####################
sub unsequre
{
	local $_=$_[0];
	s/&quot;/"/g;
	s/&gt;/>/g;
	s/&lt;/</g;
	if($_[1]!=1){
		s/<br>\n/\n/g;
	}
	s/&amp;/&/g;
	return $_;
}
###################
#database
###################
sub doLog{
my $log=shift;
$db->do("INSERT INTO ${PREF}log (date,log) VALUES ($NOW,?)",undef,$log) if $CONF{enablelog};
}
###################
sub GetSQLCount{
	my $sql=shift;
	$sql =~ s/\blimit\b.*$//i;
	$sql=~s/select\b.*?\bfrom/SELECT count(*) AS count FROM/i;
	my $out=$db->prepare($sql);
	$out->execute(@_);
	&Error;
	my $hr = $out->fetchrow_hashref;	
	return $hr->{count};
}
###################
sub select_one_db{
my $sql=shift;
my @args=@_;
my $out=$db->prepare($sql);
$out->execute(@args);
&Error;
return $out->fetchrow_hashref;
}
###################
sub insert_db{
	my $table=shift;
	my $h_ref=shift;
	
	$sql="SHOW columns FROM $table";
	my $out=$db->prepare($sql);
	$out->execute();
	my %defaults;
	while (my @output=@{$out->fetchrow_arrayref}){
		$defaults{$output[0]}=$output[4];
	}
	my %col=%{$h_ref};
	my @args, @cols;
	@args=();
	@cols=();
	foreach (sort {$a cmp $b} keys %col){
		if ($col{$_} eq ''){
			$col{$_}=$defaults{$_};
		}
		push (@cols,"`$_`");
		push (@args,$db->quote($col{$_}));
	}
	my $last=GetLastInsert($table);
	my $sql="INSERT INTO $table  (".join(" , ",@cols).") VALUES (".join(" , ",@args).") ";
	$db->do($sql);
	&Error($sql);
return $last;
}
###################
sub update_db{
	my $table=shift;
	my $h_ref=shift;
	my $w_ref=shift;
	$sql="SHOW columns FROM $table";
	my $out=$db->prepare($sql);
	$out->execute();
	my %defaults;
	while (my @output=@{$out->fetchrow_arrayref}){
		$defaults{$output[0]}=$output[4];
	}
	my %col=%{$h_ref};
	my %where=%{$w_ref};
	my @set,@where;
	@set=();
	@where=();
	foreach (sort {$a cmp $b} keys %col){
		#set default
		if ($col{$_} eq ''){
			$col{$_}=$defaults{$_};
		}
		push (@set,"`$_`=".$db->quote($col{$_}));
	}
	foreach (sort {$a cmp $b} keys %where){
		push (@where,"`$_`=".$db->quote($where{$_}));
	}
	my $sql="UPDATE $table SET ".join(" , ",@set)." WHERE ".join(" AND ",@where); 
	my $res=$db->do($sql);
	&Error($sql);
	return $res;
}
###############################
sub Error{
	my $sql=shift;
	print $q->header if $DBI::err;
	print "SQL error: $sql : ERROR: $DBI::err - $DBI::errstr" if $DBI::err;
}
sub AddToSend{
	my $user=shift;
	my $mess=shift;
	unless (GetSQLCount("SELECT * FROM ${PREF}tosend WHERE fk_mess=? AND fk_user=?",$mess,$user)){
		$db->do("INSERT INTO ${PREF}tosend (fk_user,fk_mess) VALUES (?,?)",undef,$user,$mess);	
		$count++;
	}

}
###################
sub DeleteUser{
	my $userid=shift;		
	$db->do("DELETE FROM ${PREF}user WHERE pk_user=?",undef,$userid);
	$db->do("DELETE FROM ${PREF}tosend WHERE fk_user=?",undef,$userid);
	$db->do("DELETE FROM ${PREF}doiaccounts  WHERE fk_user=?",undef,$userid);		
	$db->do("DELETE FROM ${PREF}doppar  WHERE fk_user=?",undef,$userid);
}
###################
sub GetLastInsert{
	my %stolbs;
	my $sql=<<ALL__;
 show table status from $DATA like ?
ALL__

	my $out=$db->prepare($sql);
	$out->execute($_[0]);
	&Error($sql);
	%stolbs=%{$out->fetchrow_hashref};
	my %newst;
	map{$newst{lc($_)}=$stolbs{$_}}keys %stolbs;
	return $newst{auto_increment};
}
#####################
sub save_config{
	my $account=shift;	
	my $key=shift;
	my $value=shift;
	my $count=GetSQLCount("SELECT * FROM ${PREF}conf WHERE pk_conf=? AND fk_account=?",$key,$account);
	if ($count){
		update_db("${PREF}conf",{conf_value =>$value},{pk_conf=>$key,fk_account=>$account});
	}else{
		insert_db("${PREF}conf",{conf_value =>$value,pk_conf=>$key,fk_account=>$account});
	}
	$CONF{$key}=$value;
}
#####################
sub loadCONF{
	my $account=shift;
	my %conf;
	my $where;
	if ($account){
		$where= " where fk_account in (0,$account) ";
	}else{
		$where= " where fk_account=0 ";
	}
	my $sql="select * from ${PREF}conf $where";
	my $out=$db->prepare($sql);
	$out->execute();
	my %output;
	while (%output=%{$out->fetchrow_hashref}){
		$conf{$output{pk_conf}}=$output{conf_value};
	}
	return %conf;
}
#####################
sub db_prepare{
	open(FILE,$c_file) || die "Can not open file $c_file : $!";
	my $cr=<FILE>;
	close(FILE);
	$cr=unfs($cr,$cfg_psd x ceil(length($cr)/length($cfg_psd)));
	my %ps;
	my @sr=split(/;/,$cr);
	foreach (@sr) { /(.*?):(.*)/;$ps{$1}=$2 }
	$DATA=$ps{_db};	$USER=$ps{_us};	$PASS=$ps{_pass};$PREF=$ps{_pref};
	$BDHOST=$ps{_host};
	$BDHOST='localhost' unless $BDHOST;
	$db = DBI->connect("DBI:mysql:database=$DATA;host=$BDHOST",$USER,$PASS) ||
	die "We are not connected to database $DATA \n\n Error: $DBI::err : $DBI::errstr ";
	my $where;
	if (exists $PAR{account}){
		$where= " where fk_account in (0,$PAR{account}) ";
	}else{
		$where= " where fk_account=0 ";
	}
	##load conf
	my $sql="select * from ${PREF}conf $where";
	my $out=$db->prepare($sql);
	$out->execute();
	my %output;
	while (%output=%{$out->fetchrow_hashref}){
		$CONF{$output{pk_conf}}=$output{conf_value};
	}
	$NOW=GetNow($CONF{timecorr});
	$MY_TIME=time+TimeToSec($CONF{timecorr});
	#load accounts
	my $sql="select * from ${PREF}account";
	my $out=$db->prepare($sql);
	$out->execute();
	my %output;
	while (%output=%{$out->fetchrow_hashref}){
		$ACCOUNT{$output{pk_account}}=$output{name};
	}
	return $db;
}
sub multiSQL{
	my $sql=shift;
	my @str=split(/\n/,$sql);
	chomp @str;
	foreach(@str){
		s/^#.*//;
		s/;(\W)*$/ \n/;
	}
	my $SQL=join(" ",@str);
	@str=split(/\n/,$SQL);
	foreach (@str){
		$db->do($_);
		#&Error;
	}
}
###################
#end database
###################
#Checking
###################
sub checkemail {
	my $email = shift;
	my $isreq=shift;
	$isreq="1" if ($isreq eq '');
	if ($isreq == 0){
		return 1 if ($email eq '');
	}
	if ($email =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/ || $email !~ /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z0-9]{2,4}|[0-9]{1,3})(\]?)$/) {
		return 0;
	}
	else {
		return 1;
	}
}
########
sub check_url{
	my $url=shift;
	my $isreq=shift;
	$isreq="1" if ($isreq eq '');
	unless ($isreq){
		return 1 unless $url;
	}
	if ($url=~m#^([a-z]+):\/\/+#){
		$url=~s#^([a-z]+):\/\/+##;
		if ($1){
			unless (($1 eq 'http') || ($1 eq 'https')){
				return 0;
			}
		}
	}
	return 0 if $url=~/ /;
	if ($isreq){
		return 0 unless $url;
	}
	return 0 if $url=~/\.\.|\(|\)/;
	return 1;
}
###################
#END Checking
###################
#############
sub printenv{
	foreach (sort keys %ENV){
		print "\$ENV{$_}=$ENV{$_}<br>\n"
	}
}
sub unfsmy{
	my $what=shift;
	$what=~tr/abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789/DNfeQS5Ouj6rMkIg9PwTXHzC1Vc3vEA8nxlLF7KYbsUmJhZ4WoRqiGpy0aBd2t/;
	$what =~ s/_([\dA-Fa-f][\dA-Fa-f])/pack ("C", hex ($1))/eg;
	return $what;
}
##############
########################
sub fisher_yates_shuffle {
    my $array = shift;
    my $i;
    for ($i = @$array; --$i; ) {
        my $j = int rand ($i+1);
        next if $i == $j;
        @$array[$i,$j] = @$array[$j,$i];
    }
}

sub unfs {
    local($text, $key) = @_;
    local($response) = '';
    local($i, $j, $num, $result);
    local($text_len) = length($text);
    local($key_len) = length($key);
    for ($i = $text_len - 1; $i >= 0; --$i) {
        $num = ord(chop($text));
        if ($num == 127) { $num = 58 }
        $num -= 32;
        for ($j = $i; $j < $key_len; $j += $text_len) {
            $num -= ord(substr($key, $j, 1)) + $key_len;
        }
        $num = $num % 95 + 32;
        $result .= pack("c", $num);
    }
    return($result);
} 
sub fs {
    local($text, $key) = @_;
    local($response) = '';
    local($i, $j, $num, $result);
    local($text_len) = length($text);
    local($key_len) = length($key);
    for ($i = 0; $i < $text_len; ++$i) {
        $num = ord(chop($text)) - 32;
        for ($j = $i; $j < $key_len; $j += $text_len) {
            $num += ord(substr($key, $j, 1)) + $key_len;
        }
        $num = $num % 95 + 32;
        if ($num == 58) { $num = 127 };
        $result .= pack("c", $num);
    }
      return($result);
}
##################
#TIME SYNCHRONISATION
##################
sub GetStartDay{
my $now=shift;
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =  localtime($now);
return timelocal(0,0,0,$mday,$mon,$year);
}
###################
sub GetNow{
        my $now;
        my $add=shift;
	return ("NOW()") if ($add eq "");
        if ($add=~s/^-//){
                $now="DATE_SUB(NOW(), INTERVAL '$add' HOUR_MINUTE)";
                }else{
                $now="DATE_ADD(NOW(), INTERVAL '$add' HOUR_MINUTE)";
                }
        return $now;
}
#############################
sub TimeToSec{
        my $time=shift;
        my $k=1;
        if ($time=~s/^-//){
                        $k=-1;
                }else{
                        $k=1;
                }
        chomp ($time);
        my ($h,$m,$s)=split(/:/,$time);
        return ($s+$m*60+$h*60*60)*$k;
}
##################################################
sub GetDate{
        my $noadd=shift;
        my $add;
        $add=0 if $noadd;
        $add=TimeToSec($CONF{timecorr}) unless $noadd;
        my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time + $add);
        $year += 1900;
        $mon++;
                $mon = sprintf("%02d", $mon);
                $mday = sprintf("%02d", $mday);
                $hour = sprintf("%02d", $hour);
                $min = sprintf("%02d", $min);
                $sec = sprintf("%02d", $sec);
                return "$year-$mon-$mday $hour:$min:$sec";
}

################
sub mimeformat {
    my($filename) = @_;
    my($result);

    my %extensions = ( 
        gif      => ['image/GIF' , 'base64'],
        txt      => ['text/plain' , '8bit'],
        com      => ['text/plain' , '8bit'],
        doc      => ['application/msword', 'base64'],
        class    => ['application/octet-stream' , 'base64'],
        htm      => ['text/html' , '8bit'],
        html     => ['text/html' , '8bit'],
        htmlx    => ['text/html' , '8bit'],
        htx      => ['text/html' , '8bit'],
        jpg      => ['image/jpeg' , 'base64'],
        pdf      => ['application/pdf' , 'base64'],
        mpeg     => ['video/mpeg' , 'base64'],
        mov      => ['video/quicktime' , 'base64'],
        exe      => ['application/octet-stream' , 'base64'],
        zip      => ['application/zip' , 'base64'],
        au       => ['audio/basic' , 'base64'],
        mid      => ['audio/midi' , 'base64'],
        midi     => ['audio/midi' , 'base64'],
        wav      => ['audio/x-wav' , 'base64'],
        tar      => ['application/tar' , 'base64']
    ); # %extensions

    if ($filename =~ /.*\.(.+)$/) {
        $ext = $1;
    } # if

    if (exists($extensions{$ext})) {
        $result = $extensions{$ext};
    } # if
    else {
        $result = ['BINARY', 'base64'];
    } # else

    return $result;
}
############################
sub MIMEsendto{
	my $to=shift;
	my $msg=shift;
	if ($CONF{modsend} eq 'SMTP'){
		$smtp = Net::SMTP->new($CONF{smtp});
		$smtp->mail($to);
		$smtp->to($to);
		$smtp->data();
		$smtp->datasend($msg->as_string);
		$smtp->dataend();
		$smtp->quit;
	}else{
		open(SENDMAIL, "|".$CONF{sendmail}." -i -t");
		print SENDMAIL $msg->as_string;
		close(SENDMAIL);

	}

}
#######################
sub loaduser{
	my $userid=shift;
	my $user;
	$user=select_one_db("SELECT * FROM ${PREF}user WHERE pk_user=?",$userid);
	$sql="SELECT * FROM ${PREF}doppar WHERE fk_user=?";
	my $out=$db->prepare($sql);
	$out->execute($userid);
	while (my %output=%{$out->fetchrow_hashref}){
		$user->{doppar}{$output{fk_fields}}=$output{value};	
	}
	return $user;
}
#######################
sub load_mess{
my $mess=shift;
my $SQL=<<ALL__;
SELECT 
	pk_mess,mess,subject,days,sent,type,typesend,
	DATE_FORMAT(senddat, '%Y-%b-%d' ) as senddat, 
	DAYOFMONTH(senddat) as n_day,
	MONTH(senddat) as n_month,
	YEAR(senddat) as n_year
FROM ${PREF}mess 	
WHERE pk_mess=?
ALL__
$mess_ref=select_one_db($SQL,$mess);
$mess_ref->{ATTACH}=load_mess_attachment($mess);
return $mess_ref;
}
#########################
sub load_mess_attachment{
	my $pk_mess=shift;
	my %attach;
	my $out=$db->prepare("SELECT * FROM ${PREF}attach WHERE fk_mess=?");
	$out->execute($pk_mess);
	while (my %output=%{$out->fetchrow_hashref}){
		my $id=$output{pk_attach};delete($output{pk_attach});
		$attach{$id}=\%output;
	}
	return \%attach;
}
######################
sub save_user_parametr{
	my $field=shift;
	my $user=shift;
	my $value=shift;
	return if $field=~/[^0-9]/;
	return if $user=~/[^0-9]/;
	if ($value eq ""){
		$db->do("DELETE FROM ${PREF}doppar WHERE fk_fields=? AND fk_user=?",undef,$field,$user);
		return;
	}
	my $count=GetSQLCount("SELECT * FROM ${PREF}doppar WHERE fk_fields=? AND fk_user=?",$field,$user);
	if ($count){
		update_db("${PREF}doppar",{value =>$value},{fk_fields=>$field,fk_user=>$user});
	}else{
		insert_db("${PREF}doppar",{value =>$value,fk_fields=>$field,fk_user=>$user});
	}
}
#################
sub load_account_fields{
my $account=shift;
my @FIELDS;	
my $sql="SELECT * from ${PREF}fields WHERE fk_account=? ORDER BY `rang` ASC ";
	my $out=$db->prepare($sql);
	$out->execute($account);
	&Error($sql);
	my %output;
	while (%output=%{$out->fetchrow_hashref}){
		push(@FIELDS,{key=>$output{pk_fields},name=>$output{fieldname},rang=>$output{rang},type=>$output{type},is_req=>$output{is_req}});
	}
return 	@FIELDS;
}
sub preparename{
	my $user=shift;
	$user=~s/[^A-Za-z0-9\-.]/ /g;
	$user=~s/^ +//;
	$user=~s/ +$//;
	while ($user=~s/  / /g){}
	my @words=split(/ /,$user);
	@words=map{ucfirst(lc($_))}@words;
	my $name=join(' ',@words);
	return $name;
}
sub prepareemail{
	return lc(shift);
}
